(* Time-stamp: <modified the 20/03/2019 (at 15:02) by Erwan Jahier> *)

open Algo

let vars = ["clock",It]
let m=10

let (init_vars: neighbor list -> local_env) =
  fun _nl ->
    function _ -> I (Random.int m)

let list_min l =
  match l with
    [] -> assert false
  | x::l -> List.fold_left min x l

(* avoid warning when casting to int *)
let i e v = match e v with I i -> i | _ -> assert false

let new_clock_value nl e =
  let cl = List.map (fun n -> i n.lenv "clock") nl in
  let min_clock = List.fold_left min (i e "clock") cl in
  (min_clock + 1)  mod m 

let (enable_f:neighbor list -> local_env -> action list) =
  fun nl e ->
    if I (new_clock_value nl e) <> e "clock" then ["g"] else []
  
let (step_f : neighbor list -> local_env -> action -> local_env) =
  fun nl e ->
    function  | _ -> (function "clock" -> I (new_clock_value nl e) | _ -> assert false)

let () =
  let algo_id = "unison" in
  Algo.reg_vars      algo_id vars;
  Algo.reg_init_vars algo_id init_vars; 
  Algo.reg_enable    algo_id enable_f;
  Algo.reg_step      algo_id step_f;
  Algo.reg_actions   algo_id ["g"];  
  ()

